<template>
    <v-container fluid>


        <v-card max-width="1200" class="ma-auto">

            <v-alert v-if="err != ''" dense text type="error" max-width="800" class="mx-auto my-2 pa-2">
                {{err}}
            </v-alert>
            <v-alert v-if="ok != ''" dense text type="success" max-width="800" class="mx-auto my-2 pa-2">
                {{success}}
            </v-alert>

            <div class="text-h4 text-lg-h3 pa-7"> Floors</div>

            <v-list two-line>
                <v-list-item v-for="(f,i) in floors" :key="f.id">
                    <v-container>
                        <v-row>
                            <v-list-item-content>
                                <v-list-item-title>
                                    {{f.name}}
                                </v-list-item-title>
                                <v-list-item-subtitle>
                                    {{f.timeZone}} • {{f.id}}
                                </v-list-item-subtitle>
                            </v-list-item-content>
                            <v-spacer/>
                            <v-list-item-action>
                                <DeleteIcon
                                        title="Are you sure you want to delete this floor?"
                                        :text="`Are you sure you want to delete floor '${f.name}' of ID '${f.id}'`"
                                        tooltip="Delete Floor"
                                        :id="f.id"
                                        :back-f="BackDelete"
                                        :delete-f="FloorDelete"
                                />
                            </v-list-item-action>
                            <v-list-item-action>
                                <IconLinks
                                        icon="$vuetify.icons.floor"
                                        :to="`/floor/${f.id}/info`"
                                        tooltip="Floor Information"
                                />
                            </v-list-item-action>
                            <v-list-item-action>
                                <IconLinks
                                        icon="$vuetify.icons.edit"
                                        :to="`/floor/${f.id}/floorplan/edit`"
                                        tooltip="Edit Floor Plan"
                                />
                            </v-list-item-action>
                            <v-list-item-action>
                                <IconLinks
                                        icon="$vuetify.icons.show"
                                        :to="`/floor/${f.id}`"
                                        tooltip="Live Position of workers"
                                />
                            </v-list-item-action>
                            <v-list-item-action>
                                <IconLinks
                                        :href="Path(f.id)"
                                        icon="$vuetify.icons.download"
                                        tooltip="Download History CSV"
                                />
                            </v-list-item-action>
                            <v-list-item-action>
                                <v-tooltip bottom>
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-btn @click="Toggle(i)" icon v-bind="attrs" v-on="on">
                                            <v-icon color="grey lighten-1">
                                                {{ show[i] ? 'mdi-chevron-up' :'mdi-chevron-down' }}
                                            </v-icon>
                                        </v-btn>
                                    </template>
                                    <span>Show/Hide FloorPlans</span>
                                </v-tooltip>
                            </v-list-item-action>
                        </v-row>

                        <v-expand-transition>
                            <v-row v-if="show[i]">
                                <FloorPlans :floor="f.id"/>
                            </v-row>
                        </v-expand-transition>

                    </v-container>

                </v-list-item>
            </v-list>
            <v-dialog v-model="dialog" persistent max-width="600px" class="pa-4">
                <template #activator="{ on: onD, attrs: attrD }">
                    <v-tooltip bottom>
                        <template #activator="{ on: onT, attrs: attrT }">
                            <v-btn color="pink" dark absolute bottom right fab v-bind="{...attrD,...attrT}"
                                   v-on="{...onT,...onD}">

                                <v-icon>mdi-plus</v-icon>
                            </v-btn>
                        </template>
                        <span>Create New Floor</span>
                    </v-tooltip>
                </template>
                <CreateFloor :close-f="closeDialog" :create-f="refreshFloors"/>
            </v-dialog>
        </v-card>

    </v-container>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component, Vue} from 'vue-property-decorator';
    import {Mixins} from "vue-mixin-decorator";
    import {Initializable} from "../../mixins/Initializable";
    import {FloorFlyWeightResponse} from "../../../../classLibrary/core/floorFlyWeightResponse";
    import {analyticsApi, coreApi} from "../../init";
    import {Validable} from "../../mixins/Validable";
    import FloorPlans from "../../components/FloorPlans.vue";
    import CreateFloor from "./CreateFloor.vue";
    import DeleteIcon from "../../components/DeleteIcon.vue";
    import IconLinks from "../../components/IconLinks.vue";

    interface AllFloorMixin extends Initializable, Validable {
    }

    @Component({
        components: {IconLinks, DeleteIcon, CreateFloor, FloorPlans}
    })

    export default class AllFloor extends Mixins<AllFloorMixin>(Initializable, Validable) {
        floors: FloorFlyWeightResponse[] = [];
        show: boolean[] = [];
        dialog = false;
        del = false;

        refreshFloors() {
            this.update();
        }

        closeDialog() {
            this.dialog = false;
            this.ok = "";
        }

        Path(id: string): string {
            return analyticsApi.FullPath(`History/csv/${id}`);
        }

        async BackDelete(): Promise<void> {
            this.ok = "";
        }

        async FloorDelete(id: string): Promise<void> {
            const r = await coreApi.Delete(`Floor/${id}`);
            if (r) {
                this.ok = "Successfully delete floor";
                await this.update();
            } else {
                this.err = "Failed to delete floor";
            }
        }

        async Download(id: string) {

        }

        async update() {
            const fr = await coreApi.Get<FloorFlyWeightResponse[]>("Floor");
            if (fr.success) {
                this.floors = fr.Ok!;
                const diff = this.floors.length - this.show.length;
                for (let i = 0; i < diff; i++) {
                    this.show.push(false);
                }
            } else {
                this.err = fr.error!;
            }
        }

        Toggle(i: number) {
            Vue.set(this.show, i, !this.show[i]);
        }

        async init() {
            await this.update();
        }

        async mountInit() {

        }

    }
</script>
